/***********************************************************************
**                                                                    **
**  listing_10_3.c                                                    **
**                                                                    **
**  Scrolled Window Demo. This program uses a scrolled window to hold **
**  a row-column, which in turn holds ten label widgets.              **
**                                                                    **
***********************************************************************/


#include <Xm/ScrolledW.h>
#include <Xm/ScrollBar.h>
#include <Xm/RowColumn.h>
#include <Xm/Label.h>


Widget	appshell,			/* Application Shell	      */
	scroller,			/* The scrolled window        */
	rowcol,				/* The row-column             */
	labels[10];			/* The children		      */

Widget	temp;				/* Used to unmanage HScroll   */
Arg	arglist[1];			/* Ditto		      */


void main( argc, argv )
    int     argc;
    char    *argv[];
{
    appshell = XtInitialize( argv[0], "Listing_10_3", NULL, 0, &argc, argv );

    scroller = XmCreateScrolledWindow( appshell, "Scroller", NULL, 0 );
    XtManageChild( scroller );

    rowcol = XmCreateRowColumn( scroller, "RowCol", NULL, 0 );
    XtManageChild( rowcol );

    XmScrolledWindowSetAreas( scroller, NULL, NULL, rowcol );

    XtSetArg( arglist[0], XmNhorizontalScrollBar, &temp );
    XtGetValues( scroller, arglist, 1 );
    XtUnmanageChild( temp );

    labels[0] = XmCreateLabel( rowcol, "Label_0", NULL, 0 );
    labels[1] = XmCreateLabel( rowcol, "Label_1", NULL, 0 );
    labels[2] = XmCreateLabel( rowcol, "Label_2", NULL, 0 );
    labels[3] = XmCreateLabel( rowcol, "Label_3", NULL, 0 );
    labels[4] = XmCreateLabel( rowcol, "Label_4", NULL, 0 );
    labels[5] = XmCreateLabel( rowcol, "Label_5", NULL, 0 );
    labels[6] = XmCreateLabel( rowcol, "Label_6", NULL, 0 );
    labels[7] = XmCreateLabel( rowcol, "Label_7", NULL, 0 );
    labels[8] = XmCreateLabel( rowcol, "Label_8", NULL, 0 );
    labels[9] = XmCreateLabel( rowcol, "Label_9", NULL, 0 );
    XtManageChildren( labels, 10 );

    XtRealizeWidget( appshell );
    XtMainLoop();
}
